//
// Button lists margin
//
.btn-list {
    .btn {
        margin-bottom: 5px;
    }
}

//
// Circle Buttons
//
// There are mixins which we have created in mixins/mix_buttons

.btn-circle {
    border-radius: 100%;
    width: 40px;
    height: 40px;
    padding: 5px;
    line-height: 30px;

    // Different Size of Buttons
    // #####################################################################
    &.btn-sm {
        width: 35px;
        height: 35px;
        padding: 8px 10px;
        font-size: 14px;
    }

    &.btn-lg {
        width: 50px;
        height: 50px;
        padding: 14px 10px;
        font-size: 18px;
        line-height: 23px;
    }

    &.btn-xl {
        width: 70px;
        height: 70px;
        padding: 14px 15px;
        font-size: 24px;
    }
}

//
// Rounded Buttons
//
// There are mixins which we have created in mixins/mix_buttons

.btn-rounded {
    border-radius: 60px;
    padding: 7px 18px;

    // Different Size of Buttons
    // #####################################################################
    &.btn-xs {
        padding: .25rem .5rem;
        font-size: 10px;
    }

    &.btn-sm {
        padding: .25rem .5rem;
        font-size: 12px;
    }

    &.btn-md {
        padding: 12px 35px;
        font-size: 16px;
    }

    &.btn-lg {
        padding: .75rem 1.5rem;
    }
}

//
// Extra Small Button
//
.btn-xs {
    padding: .25rem .5rem;
    font-size: 10px;
}

//
// Active with icons
//
.btn {
    .text-active {
        display: none;
    }

    &.active {
        .text-active {
            display: inline-block;
        }
    }

    // Pills Buttons
    &.btn-pill.btn-wide,
    &.btn-pill {
        @include border-left-radius(50px);
        @include border-right-radius(50px);
    }
}

//
// Vertical Icons
//
.btn-icon-vertical {
    padding-top: ($btn-block-spacing-y * 2);
    padding-bottom: ($btn-block-spacing-y * 2);

    .btn-icon-wrapper {
        display: block;
        font-size: 200%;
        margin: 5px 0;
        opacity: .6;
    }

    &.btn-link {
        text-decoration: none;
    }

    &.btn-lg:not(.btn-block) {
        .btn-icon-wrapper {
            font-size: 25px;
        }
    }

    &.btn-sm:not(.btn-block) {
        .btn-icon-wrapper {
            font-size: 16px;
        }
    }

    &:active,
    &.active,
    &:hover {
        .btn-icon-wrapper {
            opacity: 1;
        }
    }

    &.btn-icon-bottom {
        .btn-icon-wrapper {
            margin: ($spacer / 5) 0 5px;
        }
    }

    &.btn-transition-text {
        .btn-icon-wrapper {
            transition: all .2s !important;
        }

        &:hover {
            .btn-icon-wrapper {
                transform: scale(1.3);
            }
        }

        &.btn-transition-alt {

            &:hover {
                .btn-icon-wrapper {
                    color: $white !important;
                }
            }
        }
    }
}

// Buttons Gradients
$btn-gradients: ();

$gradient-primary: $primary;
$gradient-secondary: $gray-600;
$gradient-success: $green;
$gradient-info: $cyan;
$gradient-warning: $lightorange;
$gradient-danger: $red;
//$gradient-light: $blue-light;
$gradient-dark: $gray-800;
$gradient-focus: $indigo;
$gradient-alt: $purple;

$gradient-percent: 15%;

$btn-gradients: map_merge(
    (
        "primary": (
            darken($gradient-primary, $gradient-percent), // color-start
            $gradient-primary, // color-end
            0%, // gr-start
        ),
        "secondary": (
            darken($gradient-secondary, $gradient-percent), // color-start
            $gradient-secondary, // color-end
            0%, // gr-start
        ),
        "success": (
            darken($gradient-success, $gradient-percent), // color-start
            $gradient-success, // color-end
            0%, // gr-start
        ),
        "info": (
            darken($gradient-info, $gradient-percent), // color-start
            $gradient-info, // color-end
            0%, // gr-start
        ),
        "warning": (
            darken($gradient-warning, $gradient-percent), // color-start
            $gradient-warning, // color-end
            0%, // gr-start
        ),
        "danger": (
            darken($gradient-danger, $gradient-percent), // color-start
            $gradient-danger, // color-end
            0%, // gr-start
        ),
        "focus": (
            darken($gradient-focus, $gradient-percent), // color-start
            $gradient-focus, // color-end
            0%, // gr-start
        ),
        "alternate": (
            darken($gradient-alt, $gradient-percent), // color-start
            $gradient-alt, // color-end
            0%, // gr-start
        ),
        //"light": (
        //    darken($gradient-light, $gradient-percent), // color-start
        //    $gradient-light, // color-end
        //    0%, // gr-start
        //),
        "dark": (
            darken($gradient-dark, $gradient-percent), // color-start
            $gradient-dark, // color-end
            0%, // gr-start
        ),
    ),
    $btn-gradients
);

@mixin btn-grad-variant($color-start, $color-end, $gr-start) {
    background-image: linear-gradient(140deg, $color-start -30%, $color-end 90%);
    background-color: $color-start;
    border-color: $color-start;
    color: color-yiq(darken($color-start, 10%));

    &.active,
    &:active,
    &:not(:disabled):not(.disabled):hover {
        background-image: linear-gradient(120deg, darken($color-start, 3%) 0%, darken($color-end, 3%) 100%);
        color: color-yiq(darken($color-start, 10%));
        border-color: darken($color-start, 10%);
    }

    &:focus,
    &.focus,
    &:active,
    &.active {
        color: color-yiq(darken($color-start, 10%)) !important;
        border-color: darken($color-end, 20%) !important;
    }

}

@each $grad, $colors in $btn-gradients {
    $color: nth($colors, 1);
    $color1: nth($colors, 2);
    $color2: nth($colors, 3);

    .btn-gradient-#{$grad} {
        @include btn-grad-variant($color, $color1, $color2);

        &.btn-shadow {
            box-shadow: 0 0.125rem 0.625rem rgba($color1, .4), 0 0.0625rem 0.125rem rgba($color1, .5);

            &:hover {
                box-shadow: 0 0.125rem 0.625rem rgba($color1, .5), 0 0.0625rem 0.125rem rgba($color1, .6);
            }
        }
    }
}

.btn.btn-shadow {
    &.active {
        box-shadow: 0 0 0 0 transparent !important;
    }
}

// Links

$link-color: theme-color("primary");
$link-hover-color: darken($link-color, 15%);

// Generate Buttons

@each $color, $value in $theme-colors {
    .btn-#{$color} {
        @include button-variant($value, $value);

        &.btn-shadow {
            box-shadow: 0 0.125rem 0.625rem rgba($value, .4), 0 0.0625rem 0.125rem rgba($value, .5);

            &:hover {
                box-shadow: 0 0.125rem 0.625rem rgba($value, .5), 0 0.0625rem 0.125rem rgba($value, .6);
            }
        }
    }
}

@each $color, $value in $theme-colors {
    .btn-shadow-#{$color} {
        &:hover {
            box-shadow: 0 0.125rem 0.625rem rgba($value, .4), 0 0.0625rem 0.125rem rgba($value, .5);
        }
    }
}

@each $color, $value in $theme-colors {
    .btn-outline-#{$color} {
        @include button-outline-variant($value);

        &.btn-shadow {
            box-shadow: 0 0.125rem 0.625rem rgba($value, .4), 0 0.0625rem 0.125rem rgba($value, .5);

            &.active:hover,
            &.disabled:hover,
            &:active:hover,
            &:disabled:hover {
                box-shadow: 0 0.125rem 0.625rem rgba($value, .5), 0 0.0625rem 0.125rem rgba($value, .6);
            }

            &:hover {
                box-shadow: (0px 5px 15px 2px rgba($value, 0.19));
            }
        }
    }
}

.btn {
    position: relative;
    @include transition($btn-transition);
}

.btn-light {
    border-color: darken(#f5f5f5, 10%);
}

.btn-outline-light {
    color: darken(#f5f5f5, 40%);
}